// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:srv/DeviceReport.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__DEVICE_REPORT__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__DEVICE_REPORT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/srv/detail/device_report__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const DeviceReport_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DeviceReport_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DeviceReport_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::DeviceReport_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::DeviceReport_Request & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::DeviceReport_Request>()
{
  return "microstrain_inertial_msgs::srv::DeviceReport_Request";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::DeviceReport_Request>()
{
  return "microstrain_inertial_msgs/srv/DeviceReport_Request";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::DeviceReport_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::DeviceReport_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::DeviceReport_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const DeviceReport_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: model_name
  {
    out << "model_name: ";
    rosidl_generator_traits::value_to_yaml(msg.model_name, out);
    out << ", ";
  }

  // member: model_number
  {
    out << "model_number: ";
    rosidl_generator_traits::value_to_yaml(msg.model_number, out);
    out << ", ";
  }

  // member: serial_number
  {
    out << "serial_number: ";
    rosidl_generator_traits::value_to_yaml(msg.serial_number, out);
    out << ", ";
  }

  // member: options
  {
    out << "options: ";
    rosidl_generator_traits::value_to_yaml(msg.options, out);
    out << ", ";
  }

  // member: firmware_version
  {
    out << "firmware_version: ";
    rosidl_generator_traits::value_to_yaml(msg.firmware_version, out);
    out << ", ";
  }

  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DeviceReport_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: model_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "model_name: ";
    rosidl_generator_traits::value_to_yaml(msg.model_name, out);
    out << "\n";
  }

  // member: model_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "model_number: ";
    rosidl_generator_traits::value_to_yaml(msg.model_number, out);
    out << "\n";
  }

  // member: serial_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "serial_number: ";
    rosidl_generator_traits::value_to_yaml(msg.serial_number, out);
    out << "\n";
  }

  // member: options
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "options: ";
    rosidl_generator_traits::value_to_yaml(msg.options, out);
    out << "\n";
  }

  // member: firmware_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "firmware_version: ";
    rosidl_generator_traits::value_to_yaml(msg.firmware_version, out);
    out << "\n";
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DeviceReport_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::DeviceReport_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::DeviceReport_Response & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::DeviceReport_Response>()
{
  return "microstrain_inertial_msgs::srv::DeviceReport_Response";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::DeviceReport_Response>()
{
  return "microstrain_inertial_msgs/srv/DeviceReport_Response";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::DeviceReport_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::DeviceReport_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::DeviceReport_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const DeviceReport_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DeviceReport_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DeviceReport_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::DeviceReport_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::DeviceReport_Event & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::DeviceReport_Event>()
{
  return "microstrain_inertial_msgs::srv::DeviceReport_Event";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::DeviceReport_Event>()
{
  return "microstrain_inertial_msgs/srv/DeviceReport_Event";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::DeviceReport_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::DeviceReport_Event>
  : std::integral_constant<bool, has_bounded_size<microstrain_inertial_msgs::srv::DeviceReport_Request>::value && has_bounded_size<microstrain_inertial_msgs::srv::DeviceReport_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::DeviceReport_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::DeviceReport>()
{
  return "microstrain_inertial_msgs::srv::DeviceReport";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::DeviceReport>()
{
  return "microstrain_inertial_msgs/srv/DeviceReport";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::DeviceReport>
  : std::integral_constant<
    bool,
    has_fixed_size<microstrain_inertial_msgs::srv::DeviceReport_Request>::value &&
    has_fixed_size<microstrain_inertial_msgs::srv::DeviceReport_Response>::value
  >
{
};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::DeviceReport>
  : std::integral_constant<
    bool,
    has_bounded_size<microstrain_inertial_msgs::srv::DeviceReport_Request>::value &&
    has_bounded_size<microstrain_inertial_msgs::srv::DeviceReport_Response>::value
  >
{
};

template<>
struct is_service<microstrain_inertial_msgs::srv::DeviceReport>
  : std::true_type
{
};

template<>
struct is_service_request<microstrain_inertial_msgs::srv::DeviceReport_Request>
  : std::true_type
{
};

template<>
struct is_service_response<microstrain_inertial_msgs::srv::DeviceReport_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__DEVICE_REPORT__TRAITS_HPP_
