// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:srv/GetAccelBiasModel.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_ACCEL_BIAS_MODEL__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_ACCEL_BIAS_MODEL__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Request __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Request __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetAccelBiasModel_Request_
{
  using Type = GetAccelBiasModel_Request_<ContainerAllocator>;

  explicit GetAccelBiasModel_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit GetAccelBiasModel_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetAccelBiasModel_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetAccelBiasModel_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetAccelBiasModel_Request_

// alias to use template instance with default allocator
using GetAccelBiasModel_Request =
  microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs


// Include directives for member types
// Member 'noise_vector'
// Member 'beta_vector'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Response __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Response __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetAccelBiasModel_Response_
{
  using Type = GetAccelBiasModel_Response_<ContainerAllocator>;

  explicit GetAccelBiasModel_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : noise_vector(_init),
    beta_vector(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit GetAccelBiasModel_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : noise_vector(_alloc, _init),
    beta_vector(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _noise_vector_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _noise_vector_type noise_vector;
  using _beta_vector_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _beta_vector_type beta_vector;
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__noise_vector(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->noise_vector = _arg;
    return *this;
  }
  Type & set__beta_vector(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->beta_vector = _arg;
    return *this;
  }
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetAccelBiasModel_Response_ & other) const
  {
    if (this->noise_vector != other.noise_vector) {
      return false;
    }
    if (this->beta_vector != other.beta_vector) {
      return false;
    }
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetAccelBiasModel_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetAccelBiasModel_Response_

// alias to use template instance with default allocator
using GetAccelBiasModel_Response =
  microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Event __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Event __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetAccelBiasModel_Event_
{
  using Type = GetAccelBiasModel_Event_<ContainerAllocator>;

  explicit GetAccelBiasModel_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit GetAccelBiasModel_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Event
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__GetAccelBiasModel_Event
    std::shared_ptr<microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetAccelBiasModel_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetAccelBiasModel_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetAccelBiasModel_Event_

// alias to use template instance with default allocator
using GetAccelBiasModel_Event =
  microstrain_inertial_msgs::srv::GetAccelBiasModel_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace microstrain_inertial_msgs
{

namespace srv
{

struct GetAccelBiasModel
{
  using Request = microstrain_inertial_msgs::srv::GetAccelBiasModel_Request;
  using Response = microstrain_inertial_msgs::srv::GetAccelBiasModel_Response;
  using Event = microstrain_inertial_msgs::srv::GetAccelBiasModel_Event;
};

}  // namespace srv

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_ACCEL_BIAS_MODEL__STRUCT_HPP_
