// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from microstrain_inertial_msgs:msg/GNSSRfErrorDetection.idl
// generated code does not contain a copyright notice

#include "microstrain_inertial_msgs/msg/detail/gnss_rf_error_detection__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
const rosidl_type_hash_t *
microstrain_inertial_msgs__msg__GNSSRfErrorDetection__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x99, 0x54, 0x55, 0x12, 0x60, 0x8e, 0xf3, 0x16,
      0xa7, 0xe3, 0x6b, 0x25, 0x87, 0xec, 0x47, 0x03,
      0x8b, 0x23, 0x82, 0x44, 0x66, 0x12, 0x56, 0x79,
      0x63, 0x21, 0x7e, 0xb6, 0x76, 0x79, 0x32, 0x73,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char microstrain_inertial_msgs__msg__GNSSRfErrorDetection__TYPE_NAME[] = "microstrain_inertial_msgs/msg/GNSSRfErrorDetection";

// Define type names, field names, and default values
static char microstrain_inertial_msgs__msg__GNSSRfErrorDetection__FIELD_NAME__rf_band[] = "rf_band";
static char microstrain_inertial_msgs__msg__GNSSRfErrorDetection__FIELD_NAME__jamming_state[] = "jamming_state";
static char microstrain_inertial_msgs__msg__GNSSRfErrorDetection__FIELD_NAME__spoofing_state[] = "spoofing_state";
static char microstrain_inertial_msgs__msg__GNSSRfErrorDetection__FIELD_NAME__valid_flags[] = "valid_flags";

static rosidl_runtime_c__type_description__Field microstrain_inertial_msgs__msg__GNSSRfErrorDetection__FIELDS[] = {
  {
    {microstrain_inertial_msgs__msg__GNSSRfErrorDetection__FIELD_NAME__rf_band, 7, 7},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {microstrain_inertial_msgs__msg__GNSSRfErrorDetection__FIELD_NAME__jamming_state, 13, 13},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {microstrain_inertial_msgs__msg__GNSSRfErrorDetection__FIELD_NAME__spoofing_state, 14, 14},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {microstrain_inertial_msgs__msg__GNSSRfErrorDetection__FIELD_NAME__valid_flags, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
microstrain_inertial_msgs__msg__GNSSRfErrorDetection__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {microstrain_inertial_msgs__msg__GNSSRfErrorDetection__TYPE_NAME, 50, 50},
      {microstrain_inertial_msgs__msg__GNSSRfErrorDetection__FIELDS, 4, 4},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "uint8 rf_band  # Must be one of the RF_BAND_* values\n"
  "uint8 jamming_state  # Must be one of JAMMING_STATE_* values\n"
  "uint8 spoofing_state  # Must be one of SPOOFING_STATE_* values\n"
  "uint16 valid_flags\n"
  "\n"
  "# Enum values for rf_band field\n"
  "uint8 RF_BAND_UNKNOWN = 0\n"
  "uint8 RF_BAND_L1 = 1\n"
  "uint8 RF_BAND_L2 = 2\n"
  "uint8 RF_BAND_L5 = 5\n"
  "\n"
  "# Enum values for jamming_state field\n"
  "uint8 JAMMING_STATE_UNKNOWN = 0\n"
  "uint8 JAMMING_STATE_NONE = 1\n"
  "uint8 JAMMING_STATE_PARTIAL = 2\n"
  "uint8 JAMMING_STATE_SIGNIFICANT = 3\n"
  "\n"
  "# Enum values for spoofing_state field\n"
  "uint8 SPOOFING_STATE_UNKNOWN = 0\n"
  "uint8 SPOOFING_STATE_NONE = 1\n"
  "uint8 SPOOFING_STATE_PARTIAL = 2\n"
  "uint8 SPOOFING_STATE_SIGNIFICANT = 3";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
microstrain_inertial_msgs__msg__GNSSRfErrorDetection__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {microstrain_inertial_msgs__msg__GNSSRfErrorDetection__TYPE_NAME, 50, 50},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 658, 658},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
microstrain_inertial_msgs__msg__GNSSRfErrorDetection__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *microstrain_inertial_msgs__msg__GNSSRfErrorDetection__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
