// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:srv/SetComplementaryFilter.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_COMPLEMENTARY_FILTER__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_COMPLEMENTARY_FILTER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Request __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Request __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetComplementaryFilter_Request_
{
  using Type = SetComplementaryFilter_Request_<ContainerAllocator>;

  explicit SetComplementaryFilter_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->north_comp_enable = 0;
      this->up_comp_enable = 0;
      this->north_comp_time_const = 0.0f;
      this->up_comp_time_const = 0.0f;
    }
  }

  explicit SetComplementaryFilter_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->north_comp_enable = 0;
      this->up_comp_enable = 0;
      this->north_comp_time_const = 0.0f;
      this->up_comp_time_const = 0.0f;
    }
  }

  // field types and members
  using _north_comp_enable_type =
    int8_t;
  _north_comp_enable_type north_comp_enable;
  using _up_comp_enable_type =
    int8_t;
  _up_comp_enable_type up_comp_enable;
  using _north_comp_time_const_type =
    float;
  _north_comp_time_const_type north_comp_time_const;
  using _up_comp_time_const_type =
    float;
  _up_comp_time_const_type up_comp_time_const;

  // setters for named parameter idiom
  Type & set__north_comp_enable(
    const int8_t & _arg)
  {
    this->north_comp_enable = _arg;
    return *this;
  }
  Type & set__up_comp_enable(
    const int8_t & _arg)
  {
    this->up_comp_enable = _arg;
    return *this;
  }
  Type & set__north_comp_time_const(
    const float & _arg)
  {
    this->north_comp_time_const = _arg;
    return *this;
  }
  Type & set__up_comp_time_const(
    const float & _arg)
  {
    this->up_comp_time_const = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Request
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetComplementaryFilter_Request_ & other) const
  {
    if (this->north_comp_enable != other.north_comp_enable) {
      return false;
    }
    if (this->up_comp_enable != other.up_comp_enable) {
      return false;
    }
    if (this->north_comp_time_const != other.north_comp_time_const) {
      return false;
    }
    if (this->up_comp_time_const != other.up_comp_time_const) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetComplementaryFilter_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetComplementaryFilter_Request_

// alias to use template instance with default allocator
using SetComplementaryFilter_Request =
  microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs


#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Response __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Response __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetComplementaryFilter_Response_
{
  using Type = SetComplementaryFilter_Response_<ContainerAllocator>;

  explicit SetComplementaryFilter_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit SetComplementaryFilter_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Response
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetComplementaryFilter_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetComplementaryFilter_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetComplementaryFilter_Response_

// alias to use template instance with default allocator
using SetComplementaryFilter_Response =
  microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Event __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Event __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetComplementaryFilter_Event_
{
  using Type = SetComplementaryFilter_Event_<ContainerAllocator>;

  explicit SetComplementaryFilter_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit SetComplementaryFilter_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<microstrain_inertial_msgs::srv::SetComplementaryFilter_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<microstrain_inertial_msgs::srv::SetComplementaryFilter_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Event
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__srv__SetComplementaryFilter_Event
    std::shared_ptr<microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetComplementaryFilter_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetComplementaryFilter_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetComplementaryFilter_Event_

// alias to use template instance with default allocator
using SetComplementaryFilter_Event =
  microstrain_inertial_msgs::srv::SetComplementaryFilter_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace microstrain_inertial_msgs
{

namespace srv
{

struct SetComplementaryFilter
{
  using Request = microstrain_inertial_msgs::srv::SetComplementaryFilter_Request;
  using Response = microstrain_inertial_msgs::srv::SetComplementaryFilter_Response;
  using Event = microstrain_inertial_msgs::srv::SetComplementaryFilter_Event;
};

}  // namespace srv

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_COMPLEMENTARY_FILTER__STRUCT_HPP_
