// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:srv/SetEstimationControlFlags.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_ESTIMATION_CONTROL_FLAGS__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_ESTIMATION_CONTROL_FLAGS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "microstrain_inertial_msgs/srv/detail/set_estimation_control_flags__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetEstimationControlFlags_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: flags
  {
    out << "flags: ";
    rosidl_generator_traits::value_to_yaml(msg.flags, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetEstimationControlFlags_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "flags: ";
    rosidl_generator_traits::value_to_yaml(msg.flags, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetEstimationControlFlags_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request>()
{
  return "microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request>()
{
  return "microstrain_inertial_msgs/srv/SetEstimationControlFlags_Request";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetEstimationControlFlags_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetEstimationControlFlags_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetEstimationControlFlags_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response>()
{
  return "microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response>()
{
  return "microstrain_inertial_msgs/srv/SetEstimationControlFlags_Response";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace microstrain_inertial_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetEstimationControlFlags_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetEstimationControlFlags_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetEstimationControlFlags_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace microstrain_inertial_msgs

namespace rosidl_generator_traits
{

[[deprecated("use microstrain_inertial_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const microstrain_inertial_msgs::srv::SetEstimationControlFlags_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  microstrain_inertial_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use microstrain_inertial_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const microstrain_inertial_msgs::srv::SetEstimationControlFlags_Event & msg)
{
  return microstrain_inertial_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Event>()
{
  return "microstrain_inertial_msgs::srv::SetEstimationControlFlags_Event";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Event>()
{
  return "microstrain_inertial_msgs/srv/SetEstimationControlFlags_Event";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Event>
  : std::integral_constant<bool, has_bounded_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request>::value && has_bounded_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::SetEstimationControlFlags>()
{
  return "microstrain_inertial_msgs::srv::SetEstimationControlFlags";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::SetEstimationControlFlags>()
{
  return "microstrain_inertial_msgs/srv/SetEstimationControlFlags";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags>
  : std::integral_constant<
    bool,
    has_fixed_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request>::value &&
    has_fixed_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response>::value
  >
{
};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags>
  : std::integral_constant<
    bool,
    has_bounded_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request>::value &&
    has_bounded_size<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response>::value
  >
{
};

template<>
struct is_service<microstrain_inertial_msgs::srv::SetEstimationControlFlags>
  : std::true_type
{
};

template<>
struct is_service_request<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Request>
  : std::true_type
{
};

template<>
struct is_service_response<microstrain_inertial_msgs::srv::SetEstimationControlFlags_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__SET_ESTIMATION_CONTROL_FLAGS__TRAITS_HPP_
